import { LitElement, PropertyValues } from 'lit-element';
import { MutationTestResult } from 'mutation-testing-report-schema';
import { MetricsResult } from 'mutation-testing-metrics';
import { Subscription } from 'rxjs';
export declare class MutationTestReportAppComponent extends LitElement {
    report: MutationTestResult | undefined;
    rootModel: MetricsResult | undefined;
    src: string | undefined;
    errorMessage: string | undefined;
    context: MetricsResult | undefined;
    path: ReadonlyArray<string>;
    titlePostfix: string | undefined;
    theme: string | undefined;
    get title(): string;
    firstUpdated(): void;
    private loadData;
    updated(changedProperties: PropertyValues): Promise<void>;
    private updateModel;
    private updateContext;
    private updateTitle;
    themeSwitch: (event: CustomEvent<string>) => void;
    static styles: import("lit-element").CSSResult[];
    readonly subscriptions: Subscription[];
    connectedCallback(): void;
    disconnectedCallback(): void;
    private renderTitle;
    render(): import("lit-element").TemplateResult;
    private renderErrorMessage;
    private renderReport;
    private renderFileReport;
    private renderTotals;
}
//# sourceMappingURL=index.d.ts.map